//(c) Sergey Krotkich, Kharkov, Ukraine, 2009
//mailto: skrotkich@ukr.net
//
//    
// -    ASP-;
// -  ASP-;
// -  .

unit AppServerClass;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Wininet, StdCtrls, ComCtrls, Sockets, OleCtrls, SHDocVw,
  ExtCtrls, Buttons, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  IdHTTP, IdCoder, IdCoder3to4, IdCoderMIME,
  UnitINI, ImgList, ToolWin;

type
  TAppServer = class(TObject)
  private
    { Private declarations }
    IdHTTP1: TIdHTTP;
    PostData:TStringList;
    function UrlEncode(Str: string): string;
    function fAnsiPos(const Substr, S: string; FromPos: integer): Integer;
  public
    { Publick declarations }
    constructor Create();
    destructor Destroy; override;
    Function Execute(Const URLPortal, TempPortal, UserName, v7Script: String): String;
    Function OpenURL(Const URL: String; Const PostData: TStringList): String;
  end;

implementation
Uses
  MainForm;

{
http://delphiworld.narod.ru/base/encode_url.html
**** UBPFD *********** by delphibase.endimus.com ****
>> URL  

    URL    
 http . ..  -    
'_'  ,    '+',    
   '%'    .

: Windows
:       Dimka Maslov, mainbox@endimus.ru, ICQ:148442121, -
Copyright:   Dimka Maslov
:        27  2002 .
***************************************************** }

function TAppServer.UrlEncode(Str: string): string;

  function CharToHex(Ch: Char): Integer;
  asm
    and eax, 0FFh
    mov ah, al
    shr al, 4
    and ah, 00fh
    cmp al, 00ah
    jl @@10
    sub al, 00ah
    add al, 041h
    jmp @@20
@@10:
    add al, 030h
@@20:
    cmp ah, 00ah
    jl @@30
    sub ah, 00ah
    add ah, 041h
    jmp @@40
@@30:
    add ah, 030h
@@40:
    shl eax, 8
    mov al, '%'
  end;

var
  i, Len: Integer;
  Ch: Char;
  N: Integer;
  P: PChar;
begin
  Result := '';
  Len := Length(Str);
  P := PChar(@N);
  for i := 1 to Len do
  begin
    Ch := Str[i];
    if Ch in ['0'..'9', 'A'..'Z', 'a'..'z', '_'] then
      Result := Result + Ch
    else
    begin
      if Ch = ' ' then
        Result := Result + '+'
      else
      begin
        N := CharToHex(Ch);
        Result := Result + P;
      end;
    end;
  end;
end;

{ **** UBPFD *********** by delphibase.endimus.com ****
>>        ( )

 
Substr - , S - , fromPos -    
   ,  0
 -   ansiStrPos

: SysUtils
:       Romkin, romkin@pochtamt.ru, 
Copyright:   Romkin
:        18  2002 .
***************************************************** }

function TAppServer.fAnsiPos(const Substr, S: string; FromPos: integer): Integer;
var
  P: PChar;
begin
  Result := 0;
  P := AnsiStrPos(PChar(S) + fromPos - 1, PChar(SubStr));
  if P <> nil then
    Result := Integer(P) - Integer(PChar(S)) + 1;
end;

constructor TAppServer.Create();
begin
  IdHTTP1   := TIdHTTP.Create();
  PostData  := TStringList.Create;
end;

destructor TAppServer.Destroy;
begin
  IdHTTP1.Free;
  PostData.Free;
end;

//=================================
// URLPortal - URL 
// TempPortal -  ,     WEB-
// UserName
// v7Script
Function TAppServer.Execute(Const URLPortal, TempPortal, UserName, v7Script: String): String;
var
  s, URLWS1C, URLASP: String;
  i, j: Integer;
begin
  Result := '';

  if Length(v7Script) = 0 then
    Exit;

  PostData.Clear;
  Application.ProcessMessages;
  PostData.Add('v7Script=' + UrlEncode(v7Script));
  PostData.Add('USER=' + UrlEncode(UserName));
  PostData.Add('TEMPPORTAL=' + UrlEncode(TempPortal));
  PostData.Add('URLPORTAL=' + UrlEncode(URLPortal));

  URLWS1C   := ReadIni('MAIN', 'URLWS1C', 'http://localhost/cgi-bin/ws1c.exe/');
  URLWS1C   := URLWS1C + UserName;

  //    
  try
    s := IdHTTP1.Post(URLWS1C, PostData);
    i := fAnsiPos('http:', s, 1);
    if i > 0 then Begin
      j := fAnsiPos('<', s, i);
      URLASP := Copy(s, i, j - i);
      PostData.Clear;
      //  .
      //   ASP-
      //      .
      //     .
      // , :
      //    PostData.Add('Parametr=1234');
      //       :
      //     = Request.QueryString("Parametr").Item;
      Result := IdHTTP1.Post(URLASP, PostData);
    End;
  except
    ShowMessage('Error code: '+IntToStr(GetLastError)+'. '+SysErrorMessage(GetLastError));
  end;
end;

Function TAppServer.OpenURL(Const URL: String; Const PostData: TStringList): String;
Begin
  try
    Result := IdHTTP1.Post(URL, PostData);
  except
    ShowMessage('Error code: '+IntToStr(GetLastError)+'. '+SysErrorMessage(GetLastError));
  end;

End;

end.
