unit UnitINI;

{
  CGI-.
   .
}

interface
uses
  IniFiles, SysUtils, WinTypes, WinProcs;

  function ReadIni(ASection, AString, ADefault : String) : String;
  procedure WriteIni(ASection, AString, AValue : String);
  Procedure Log(const str: String; const save: Boolean = true);

implementation

Procedure Log(const str: String; const save: Boolean = true);
Var
  LogFileName: String;
  logf: TextFile;
  i: Integer;
Begin
  If ReadIni('MAIN', 'LOG', '1') = '0' Then
    Exit;

  if save then Begin
    LogFileName := ExtractFilePath(ParamStr(0)) + 'log.txt';
    If Not FileExists(LogFileName) Then Begin
			i := FileCreate(LogFileName);
  		if i < 0 then Exit;
			FileClose(i);
    End;
    AssignFile(logf, LogFileName);
    Append(logf);
    WriteLn(logf, DateTimeToStr(Now()) + '.' + str);
    CloseFile(logf);
  End;
End;

function ReadIni(ASection, AString, ADefault : String) : String;
var
  IniFile: TIniFile;
  IniFileName, Res: String;
const
  S = 'xyz'; {       }
begin
  IniFileName := ChangeFileExt(ParamStr(0),'.INI');
  IniFile := TIniFile.Create(IniFileName);
  Res := IniFile.ReadString(ASection, AString, S); { [Section] String=Value }
	if Res = S then
  	Result := ADefault
  Else
  	Result := Res;

  IniFile.Free;
end;

procedure WriteIni(ASection, AString, AValue : String);
var
  IniFile: TIniFile;
  IniFileName: String;
begin
  IniFileName := ChangeFileExt(ParamStr(0),'.INI');
  IniFile := TIniFile.Create(IniFileName);
  IniFile.WriteString(ASection, AString, AValue);; { [Section] String=Value }
  IniFile.Free;
end;

end.
